;;;; type-checks-numbers.scm  -*- Scheme -*-
;;;; Kon Lovett, Jun '18

(module type-checks-numbers

(;export
  check-number
  check-positive-number check-natural-number check-negative-number check-non-positive-number
  check-integer
  check-positive-integer check-natural-integer check-negative-integer check-non-positive-integer
  check-real
  check-complex
  check-rational
  check-exact
  check-inexact
  ;
  check-fixnum
  check-positive-fixnum check-natural-fixnum check-negative-fixnum check-non-positive-fixnum
  check-bignum
  check-positive-bignum check-negative-bignum check-non-positive-bignum
  check-ratnum
  check-positive-ratnum check-negative-ratnum check-non-positive-ratnum
  check-flonum check-float
  check-cplxnum)

(import scheme)
(import (chicken base))			; for `include'
(import (chicken module))
(import (chicken type))
(import (chicken fixnum))
(import type-checks-basic)
(import type-errors-numbers)

(import (type-checks-numbers interval))
(reexport (type-checks-numbers interval))

(: check-number (* * #!optional * -> number))
(: check-positive-number  (* * #!optional * -> number ))
(: check-natural-number  (* * #!optional * -> number ))
(: check-negative-number  (* * #!optional * -> number ))
(: check-non-positive-number (* * #!optional * -> number))

(: check-integer (* * #!optional * -> integer))
(: check-positive-integer (* * #!optional * -> integer))
(: check-natural-integer (* * #!optional * -> integer))
(: check-negative-integer (* * #!optional * -> integer))
(: check-non-positive-integer (* * #!optional * -> integer))

(: check-real (* * #!optional * -> number))
(: check-complex (* * #!optional * -> number))
(: check-rational (* * #!optional * -> number))

(: check-exact (* * #!optional * -> number))
(: check-inexact (* * #!optional * -> number))

(: check-fixnum (* * #!optional * -> fixnum))
(: check-positive-fixnum (* * #!optional * -> fixnum))
(: check-natural-fixnum  (* * #!optional * -> fixnum ))
(: check-negative-fixnum  (* * #!optional * -> fixnum ))
(: check-non-positive-fixnum (* * #!optional * -> fixnum))

(: check-bignum (* * #!optional * -> bignum))
(: check-positive-bignum (* * #!optional * -> bignum))
(: check-negative-bignum (* * #!optional * -> bignum))
(: check-non-positive-bignum (* * #!optional * -> bignum))

(: check-ratnum (* * #!optional * -> ratnum))
(: check-positive-ratnum (* * #!optional * -> ratnum))
(: check-negative-ratnum (* * #!optional * -> ratnum))
(: check-non-positive-ratnum (* * #!optional * -> integer))

(: check-flonum (* * #!optional * -> float))
(: check-float (* * #!optional * -> float))

(: check-cplxnum (* * #!optional * -> cplxnum))

(include "type-checks-numbers.impl")

) ;module type-checks-numbers
